import * as React from "react";
import * as PropTypes from "prop-types";
import { DraggableData, DraggableEvent } from "react-draggable";
import { AXIS_DIRECTION, ElementPropsWithElementRefAndRenderer } from "./common";
export declare type DragCallbackData = Pick<DraggableData, Exclude<keyof DraggableData, "node">>;
export declare type ScrollbarThumbProps = ElementPropsWithElementRefAndRenderer & {
    axis: AXIS_DIRECTION;
    onDrag?: (data: DragCallbackData) => void;
    onDragStart?: (data: DragCallbackData) => void;
    onDragEnd?: (data: DragCallbackData) => void;
    ref?: (ref: ScrollbarThumb | null) => void;
};
export default class ScrollbarThumb extends React.Component<ScrollbarThumbProps, {}> {
    private prevUserSelect;
    private prevOnSelectStart;
    initialOffsetX: number;
    initialOffsetY: number;
    lastDragData: DragCallbackData;
    element: HTMLDivElement | null;
    static propTypes: {
        axis: PropTypes.Requireable<AXIS_DIRECTION>;
        onDrag: PropTypes.Requireable<(...args: any[]) => any>;
        onDragStart: PropTypes.Requireable<(...args: any[]) => any>;
        onDragEnd: PropTypes.Requireable<(...args: any[]) => any>;
        elementRef: PropTypes.Requireable<(...args: any[]) => any>;
        renderer: PropTypes.Requireable<(...args: any[]) => any>;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    private static selectStartReplacer;
    handleOnDragStart: (ev: DraggableEvent, data: DraggableData) => void;
    handleOnDrag: (ev: DraggableEvent, data: DraggableData) => void;
    handleOnDragStop: (ev?: MouseEvent | React.MouseEvent<HTMLElement | SVGElement, MouseEvent> | React.TouchEvent<HTMLElement | SVGElement> | TouchEvent | undefined, data?: DraggableData | undefined) => void;
    handleOnMouseDown: (ev: MouseEvent) => void;
    render(): React.ReactElement<any> | null;
    private elementRef;
}
